package financeiro.usuario;

import java.util.List;

import financeiro.categoria.Categoria;
import financeiro.categoria.CategoriaRN;
import financeiro.util.DAOFactory;

public class UsuarioRN {

	private UsuarioDAO usuarioDAO;

	public UsuarioRN() {
		this.usuarioDAO = DAOFactory.criarUsuarioDAO();
	}

	public void salvar(Usuario usuario) {
		Integer codigo = usuario.getCodigo();
		Categoria categoria = new Categoria();
		CategoriaRN categoriaRN = new CategoriaRN();
		if (codigo == null || codigo == 0) {
			usuario.getPermissao().add("ROLE_USUARIO");
			this.usuarioDAO.salvar(usuario);
			categoriaRN.salvaEstruturaPadrao(usuario);
		} else {
			if (categoria.getCodigo() == null){
				this.usuarioDAO.atualizar(usuario);
				categoriaRN.salvaEstruturaPadrao(usuario);
			}
			this.usuarioDAO.atualizar(usuario);
		}

	}

	public void excluir(Usuario usuario) {
		CategoriaRN categoriaRN = new CategoriaRN();
		categoriaRN.excluir(usuario);
		this.usuarioDAO.excluir(usuario);
	}

	public Usuario carregar(Integer codigo) {
		return this.usuarioDAO.carregar(codigo);
	}

	public Usuario buscarPorLogin(String login) {
		return this.usuarioDAO.buscarPorLogin(login);
	}

	public List<Usuario> listar() {
		return this.usuarioDAO.listar();
	}

}
